"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.List = void 0;
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const react_native_unistyles_1 = require("react-native-unistyles");
const Section_1 = require("@procyon/components/Section");
const enums_1 = require("@procyon/types/enums");
const TextField_1 = require("./TextField");
const List = ({ options, autoComplete, onClick, compact, mode = 'interactive', style, selectedCode, }) => {
    const [focused, setFocused] = (0, react_1.useState)(undefined);
    const [selected, setSelected] = (0, react_1.useState)(selectedCode);
    const [searchResults, setSearchResults] = (0, react_1.useState)(options);
    const typingTimeoutRef = (0, react_1.useRef)();
    const { styles } = (0, react_native_unistyles_1.useStyles)(styleSheet, {
        compact,
    });
    const setSelectedOption = (code) => {
        setSelected(code);
        onClick === null || onClick === void 0 ? void 0 : onClick(code);
    };
    const handleSearch = (value) => {
        if (typingTimeoutRef.current !== undefined) {
            clearTimeout(typingTimeoutRef.current);
        }
        typingTimeoutRef.current = setTimeout(() => {
            setSearchResults(options.filter((option) => option.name.toLowerCase().includes(value.toLowerCase())));
        }, 200);
    };
    const isInteractive = mode === 'interactive';
    return (react_1.default.createElement(react_1.default.Fragment, null,
        autoComplete && (react_1.default.createElement(TextField_1.TextField, { name: "search", label: "Hledat", onChange: handleSearch, autoFocus: true, style: {
                container: {
                    marginBottom: 5,
                },
            }, size: enums_1.SizeEnum.sm })),
        react_1.default.createElement(react_native_1.ScrollView, { style: [styles.procyon_list_container(), style === null || style === void 0 ? void 0 : style.container] }, searchResults.length > 0 ? (searchResults.map(({ code, name, description }, i) => {
            var _a, _b;
            const sibling = (_b = (_a = searchResults[i - 1]) === null || _a === void 0 ? void 0 : _a.code) !== null && _b !== void 0 ? _b : null;
            return (react_1.default.createElement(react_native_1.Pressable, Object.assign({ disabled: mode === 'view' }, (isInteractive && {
                onHoverIn: () => setFocused(code),
                onHoverOut: () => setFocused(undefined),
                onPress: () => setSelectedOption(code),
            }), { key: code, style: [
                    styles.procyon_list_item(code === focused, code === selected, i === 0, i === searchResults.length - 1, sibling === focused, sibling === selected),
                    style === null || style === void 0 ? void 0 : style.item,
                ] }), description ? (react_1.default.createElement(Section_1.Section, { style: style === null || style === void 0 ? void 0 : style.section, title: name }, description)) : (react_1.default.createElement(react_native_1.Text, null, name))));
        })) : (react_1.default.createElement(react_native_1.Text, null, "Nic k zobrazen\u00ED")))));
};
exports.List = List;
const styleSheet = (0, react_native_unistyles_1.createStyleSheet)((theme) => ({
    procyon_list_container: () => (Object.assign({}, (react_native_1.Platform.OS === 'web'
        ? {
            paddingRight: theme.spacing.sm,
        }
        : {}))),
    procyon_list_item: (focused, selected, isFirst, isLast, nextSiblingFocused, nextSiblingSelected) => (Object.assign(Object.assign(Object.assign(Object.assign(Object.assign(Object.assign(Object.assign({ padding: theme.spacing.md, borderWidth: 2, borderBottomWidth: 0 }, (isFirst && {
        borderTopLeftRadius: theme.spacing.md,
        borderTopRightRadius: theme.spacing.md,
    })), (isLast && {
        borderBottomLeftRadius: theme.spacing.md,
        borderBottomRightRadius: theme.spacing.md,
        borderBottomWidth: 2,
    })), (!isFirst &&
        !isLast && {
        borderRadius: 0,
    })), (selected
        ? {
            backgroundColor: theme.common.active.background,
            borderColor: theme.common.active.border,
        }
        : focused
            ? {
                backgroundColor: theme.common.focus.background,
                borderColor: theme.common.focus.border,
            }
            : {
                borderColor: theme.components.list.item.border,
            })), (nextSiblingFocused && {
        borderTopColor: theme.common.focus.border,
    })), (nextSiblingSelected && {
        borderTopColor: theme.common.active.border,
    })), { variants: {
            compact: {
                true: {
                    padding: 1,
                },
            },
        } })),
}));
