"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Selectbox = void 0;
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const react_native_unistyles_1 = require("react-native-unistyles");
const AngleDown_1 = require("@procyon/components/Icons/AngleDown");
const useModal_1 = require("@procyon/components/Modal/useModal");
const TextField_1 = require("../TextField");
const SelectboxModal_1 = require("./components/SelectboxModal");
const Selectbox = (props) => {
    var _a;
    const { value, options, onChange, name, label, autoComplete } = props, others = __rest(props, ["value", "options", "onChange", "name", "label", "autoComplete"]);
    const { styles } = (0, react_native_unistyles_1.useStyles)(stylesheet);
    const [selectedCode, setSelectedCode] = (0, react_1.useState)(null);
    const [openModal, closeModal] = (0, useModal_1.useModal)(name, {
        title: label,
        style: { container: { maxWidth: 300 } },
        Component: (props) => (react_1.default.createElement(SelectboxModal_1.SelectboxModal, Object.assign({ autoComplete: autoComplete, name: name, options: options, closeModal: closeModal, onChange: handleOptionClick, onRemove: handleOptionRemove, selectedCode: selectedCode !== null && selectedCode !== void 0 ? selectedCode : undefined }, props))),
    });
    (0, react_1.useEffect)(() => {
        var _a, _b;
        if (value !== selectedCode) {
            const newValue = (_b = (_a = options === null || options === void 0 ? void 0 : options.find(({ code }) => code === value)) === null || _a === void 0 ? void 0 : _a.code) !== null && _b !== void 0 ? _b : null;
            setSelectedCode(newValue);
        }
    }, [value, options]);
    const handleOptionClick = (code) => {
        setSelectedCode(code);
        onChange === null || onChange === void 0 ? void 0 : onChange(code);
    };
    const handleOptionRemove = () => {
        setSelectedCode(null);
        onChange === null || onChange === void 0 ? void 0 : onChange(undefined);
    };
    const handleOpenModal = () => {
        openModal();
    };
    return (react_1.default.createElement(TextField_1.TextField, Object.assign({}, others, { readonly: true, name: name, label: label, value: (_a = options.find(({ code }) => code === selectedCode)) === null || _a === void 0 ? void 0 : _a.name, rightIcon: react_1.default.createElement(react_native_1.Pressable, { onPress: handleOpenModal, style: styles.procyon_selectbox_downIcon },
            react_1.default.createElement(AngleDown_1.AngleDownIcon, null)) })));
};
exports.Selectbox = Selectbox;
const stylesheet = (0, react_native_unistyles_1.createStyleSheet)({
    procyon_selectbox_downIcon: Object.assign({}, { cursor: 'pointer' }),
});
